# Class VulkanFramebufferCreateInfo.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanFramebufferCreateInfo.Builder

Enclosing class:
  `VulkanFramebufferCreateInfo`

public static final class VulkanFramebufferCreateInfo.Builder extends Object
Builds instances of type `VulkanFramebufferCreateInfo`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final VulkanFramebufferCreateInfo.Builder`
  `addAllAttachments(Iterable<? extends VulkanImageViewType> elements)`
  Adds elements to `attachments` list.
  `final VulkanFramebufferCreateInfo.Builder`
  `addAllFlags(Iterable<VulkanFramebufferCreateFlag> elements)`
  Adds elements to `flags` set.
  `final VulkanFramebufferCreateInfo.Builder`
  `addAttachments(VulkanImageViewType element)`
  Adds one element to `attachments` list.
  `final VulkanFramebufferCreateInfo.Builder`
  `addAttachments(VulkanImageViewType... elements)`
  Adds elements to `attachments` list.
  `final VulkanFramebufferCreateInfo.Builder`
  `addFlags(VulkanFramebufferCreateFlag element)`
  Adds one element to `flags` set.
  `final VulkanFramebufferCreateInfo.Builder`
  `addFlags(VulkanFramebufferCreateFlag... elements)`
  Adds elements to `flags` set.
  `VulkanFramebufferCreateInfo`
  `build()`
  Builds a new `VulkanFramebufferCreateInfo`.
  `final VulkanFramebufferCreateInfo.Builder`
  `from(VulkanFramebufferCreateInfoType instance)`
  Fill a builder with attribute values from the provided `VulkanFramebufferCreateInfoType` instance.
  `final VulkanFramebufferCreateInfo.Builder`
  `setAttachments(Iterable<? extends VulkanImageViewType> elements)`
  Sets or replaces all elements for `attachments` list.
  `final VulkanFramebufferCreateInfo.Builder`
  `setFlags(Iterable<VulkanFramebufferCreateFlag> elements)`
  Sets or replaces all elements for `flags` set.
  `final VulkanFramebufferCreateInfo.Builder`
  `setHeight(int height)`
  Initializes the value for the `height` attribute.
  `final VulkanFramebufferCreateInfo.Builder`
  `setLayers(int layers)`
  Initializes the value for the `layers` attribute.
  `final VulkanFramebufferCreateInfo.Builder`
  `setRenderPass(VulkanRenderPassType renderPass)`
  Initializes the value for the `renderPass` attribute.
  `final VulkanFramebufferCreateInfo.Builder`
  `setWidth(int width)`
  Initializes the value for the `width` attribute.

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanFramebufferCreateInfo.Builder from(VulkanFramebufferCreateInfoType instance)
    Fill a builder with attribute values from the provided `VulkanFramebufferCreateInfoType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanFramebufferCreateInfo.Builder addFlags(VulkanFramebufferCreateFlag element)
    Adds one element to `flags` set.
    Parameters:
      `element` - A flags element
    Returns:
      `this` builder for use in a chained invocation

  - ### addFlags

    public final VulkanFramebufferCreateInfo.Builder addFlags(VulkanFramebufferCreateFlag... elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An array of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setFlags

    public final VulkanFramebufferCreateInfo.Builder setFlags(Iterable<VulkanFramebufferCreateFlag> elements)
    Sets or replaces all elements for `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllFlags

    public final VulkanFramebufferCreateInfo.Builder addAllFlags(Iterable<VulkanFramebufferCreateFlag> elements)
    Adds elements to `flags` set.
    Parameters:
      `elements` - An iterable of flags elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setRenderPass

    public final VulkanFramebufferCreateInfo.Builder setRenderPass(VulkanRenderPassType renderPass)
    Initializes the value for the `renderPass` attribute.
    Parameters:
      `renderPass` - The value for renderPass
    Returns:
      `this` builder for use in a chained invocation

  - ### addAttachments

    public final VulkanFramebufferCreateInfo.Builder addAttachments(VulkanImageViewType element)
    Adds one element to `attachments` list.
    Parameters:
      `element` - A attachments element
    Returns:
      `this` builder for use in a chained invocation

  - ### addAttachments

    public final VulkanFramebufferCreateInfo.Builder addAttachments(VulkanImageViewType... elements)
    Adds elements to `attachments` list.
    Parameters:
      `elements` - An array of attachments elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setAttachments

    public final VulkanFramebufferCreateInfo.Builder setAttachments(Iterable<? extends VulkanImageViewType> elements)
    Sets or replaces all elements for `attachments` list.
    Parameters:
      `elements` - An iterable of attachments elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllAttachments

    public final VulkanFramebufferCreateInfo.Builder addAllAttachments(Iterable<? extends VulkanImageViewType> elements)
    Adds elements to `attachments` list.
    Parameters:
      `elements` - An iterable of attachments elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setWidth

    public final VulkanFramebufferCreateInfo.Builder setWidth(int width)
    Initializes the value for the `width` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `width`.

    Parameters:
      `width` - The value for width
    Returns:
      `this` builder for use in a chained invocation

  - ### setHeight

    public final VulkanFramebufferCreateInfo.Builder setHeight(int height)
    Initializes the value for the `height` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `height`.

    Parameters:
      `height` - The value for height
    Returns:
      `this` builder for use in a chained invocation

  - ### setLayers

    public final VulkanFramebufferCreateInfo.Builder setLayers(int layers)
    Initializes the value for the `layers` attribute.

    If not set, this attribute will have a default value as returned by the initializer of `layers`.

    Parameters:
      `layers` - The value for layers
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanFramebufferCreateInfo build()
    Builds a new `VulkanFramebufferCreateInfo`.
    Returns:
      An immutable instance of VulkanFramebufferCreateInfo
    Throws:
      `IllegalStateException` - if any required attributes are missing